/*
 * QuantityCellRenderer
 * by PhilFlash - http://philflash.inway.fr
 *
 * Dont't forget :
 * - to create a new symbol in Flash MX2004
 *   Insert > New Symbol
 *   with properties :
 *    Name : QuantityCellRenderer
 *    Behavior : MovieClip : Checked
 *   For Linkage:
 *    Identifier: QuantityCellRenderer
 *    AS 2.0 Class : renderer.RemoveCellRenderer
 *    Export for Actionscript : Checked
 *    Export for in first frame : Checked
 *
 * - to add an NumericStepper component in your library
 *
 */
 
import mx.core.UIComponent;
import mx.controls.NumericStepper;

class renderer.QuantityCellRenderer extends UIComponent
{
	private var stepper:NumericStepper;

 	var owner; // The row that contains this cell	
	var listOwner : MovieClip; // the reference we receive to the list
	var getCellIndex : Function; // the function we receive from the list
	var	getDataLabel : Function; // the function we receive from the list

	
	function QuantityCellRenderer()
	{
	}
	
	function init(Void):Void
	{
		super.init();

	}
	
	function createChildren(Void):Void
	{
		stepper = mx.controls.NumericStepper(createObject("NumericStepper", "stepper", 1));
		stepper.setSize(60, 22);
		stepper.value = 1;
		stepper.minimum = 0;
		stepper.maximum = 15;
		
		stepper.addEventListener("change", this);	

	}

	// Flash 8 has corrected a bug in DataGridRow.as line 165 
	//  cell._y = (__height-cell.height)/2;
	// In Flash MX 2004, this line was : cell._y = (__height-cell._height)/2;
	// If you have Flash MX2004, uncomment the line for Flash MX 2004 
	//  or modifiy the line 165 in DataGridRow.as
	//
	function size(Void):Void
	{
		stepper._x = (__width-60)/2;
		stepper._y = (__height-22)/2; 
		// Hack for Flash MX2004: Uncomment the next line
		//stepper._y = (_height-22)/2;
	}
	
	function setValue(value, item:Object, sel:Boolean):Void
	{
		stepper.visible = (item != undefined);
		if (item != undefined) {
			var oldValue = stepper.value;
			if (oldValue != value) {
				stepper.value = value;
			}
		}
	}
	
	function getPreferredHeight(Void):Number
	{
		return 22;
	}

 	//function getPreferredWidth :: only really necessary for menu
	
	function change(eventObj:Object):Void 
	{
		var target = eventObj.target;
		var columnIndex = this["columnIndex"];
		listOwner.dataProvider.editField(getCellIndex().itemIndex, getDataLabel(), target.value);	
		listOwner.dispatchEvent({type:"cellEdit", itemIndex:getCellIndex().itemIndex, columnIndex: columnIndex});
	}
	

}
